.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\gdi32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\gdi32.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM
SizeBoxes  PROTO :HWND

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
;Buttons
IDC_BTN1      equ 102
IDC_BTN2      equ 103
IDC_BTN3      equ 104

; Required data

.data
szId          db "__",0
szId2         db "[[]]",0
szId3         db "[ ]",0
szId4         db "X",0
.data?

hInstance HINSTANCE ?
hIcon     HICON     ?
WindowSz	dd		?
.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

 .IF uMsg == WM_INITDIALOG

;=============================================

        INVOKE  SizeBoxes,hWnd

;=============================================

INVOKE SetDlgItemText, hWnd, IDC_BTN1, ADDR szId  ; Set Minimize Window button text
INVOKE SetDlgItemText, hWnd, IDC_BTN2, ADDR szId3 ; Set MaximizeBox button text
INVOKE SetDlgItemText, hWnd, IDC_BTN3, ADDR szId4 ; Set Close Window button text

INVOKE ShowWindow,hWnd,SW_SHOWNORMAL               ; deffult window start size
mov WindowSz,1 ; This is needed to let the WindowSz MaximizeBox/MinimizeBox Button control know-
; that the window state is already at "SW_SHOWNORMAL "!
    .ELSEIF uMsg == WM_COMMAND

.IF wParam == IDC_BTN1      						; Minimize Window Button       
INVOKE ShowWindow,hWnd,SW_MINIMIZE
 .ENDIF
  
.IF wParam == IDC_BTN2      						; MaximizeBox/MinimizeBox Button  
   .IF WindowSz==1
    mov WindowSz,0
INVOKE ShowWindow,hWnd,SW_MAXIMIZE ; Maximize Window 
INVOKE SetDlgItemText, hWnd, IDC_BTN2, ADDR szId2 ; Change button text to "MinimizeBox Button"
    .ELSEIF WindowSz==0
    mov WindowSz,1
INVOKE ShowWindow,hWnd,SW_SHOWNORMAL ; Restore Window to defult size (MinimizeBox)
INVOKE SetDlgItemText, hWnd, IDC_BTN2, ADDR szId3 ; Restore Window to defult "MaximizeBox button text"
    .ENDIF
   
 .ENDIF 
.IF wParam == IDC_BTN3      						; Close Button       
INVOKE SendMessage,hWnd,WM_CLOSE,0,0
 .ENDIF

;=============================================
.ELSEIF uMsg == WM_SIZE

        INVOKE  SizeBoxes,hWnd

;=============================================

.ELSEIF uMsg == WM_LBUTTONDOWN   
invoke SendMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0 ; Move non client area of window
.ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF

    xor eax,eax
  ret
DialogProc endp

;=============================================

SizeBoxes PROC uses ebx esi edi hWnd:HWND

        mov     ebx,hWnd                     ;EBX = hWnd
        xor     edi,edi                      ;EDI = 0
        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,ebx,esp
        pop     edx                          ;discard RECT.left
        pop     ecx                          ;discard RECT.top
        INVOKE  ScreenToClient,ebx,esp
        pop     esi                          ;ESI = RECT.right
        pop     eax                          ;discard RECT.bottom
        INVOKE  GetDlgItem,ebx,IDC_BTN3
        sub     esi,25
        INVOKE  MoveWindow,eax,esi,edi,24,24,TRUE
        INVOKE  GetDlgItem,ebx,IDC_BTN2
        sub     esi,23
        INVOKE  MoveWindow,eax,esi,edi,24,24,TRUE
        INVOKE  GetDlgItem,ebx,IDC_BTN1
        sub     esi,23
        INVOKE  MoveWindow,eax,esi,edi,24,24,TRUE
        ret

SizeBoxes ENDP

;=============================================

end start